<template>
  <div>
    <div class="alert alert-info" role="alert">
      Show all CVEs affecting a specific GitLab version. Data is parsed from
      <a
        href="https://gitlab.com/gitlab-org/cves"
      >
        CVEs that have been assigned by GitLab since 2020.</a
      >
      Remove the version filter to search for CVEs across all versions.
    </div>
    <div v-if="loading">Loading...</div>
    <template v-else>
      <form>
        <div class="form-row">
          <div class="form-group col-md-2">
            <label>Affected Version</label>
            <multiselect
              v-model="version"
              :options="allVersions"
              :allowEmpty="true"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Severity</label>
            <multiselect
              v-model="selectedSeverities"
              :options="allSeverities"
              :multiple="true"
              placeholder="Select one or multiple severities"
            />
          </div>
        </div>
        <div class="form-row">
          <div
            class="form-group col-md-3"
            data-toggle="tooltip"
            data-placement="top"
          >
            <label>Fulltext search</label>
            <input
              class="form-control"
              placeholder="Search CVE ID and description"
              v-model="textSearch"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Order By</label><br />
            <div class="btn-group" role="group" aria-label="Basic example">
              <select class="custom-select" v-model="orderKey">
                <option value="severity">Severity</option>
                <option value="version">Version</option>
              </select>
              <button
                type="button"
                @click="order = order * -1"
                class="btn btn-outline-dark"
              >
                {{ order > 0 ? "Asc" : "Desc" }}
              </button>
            </div>
          </div>
        </div>
      </form>
      <paginated-table
        :items="filteredVersions"
        :total-items="versions.length"
        :per-page-default="500"
      >
        <template v-slot:header>
          <tr>
            <th>Affected Version</th>
            <th>CVE</th>
            <th>Description</th>
            <th>Severity</th>
            <th>Fix Version</th>
            <th>References</th>
          </tr>
        </template>
        <template v-slot:row="{ item: version }">
          <td>{{ version.version }}</td>
          <td>{{ version.cve_id }}</td>
          <td>{{ version.description }}</td>
          <td>{{ version.severity }}</td>
          <td>

              {{ (version.fix_versions || []).join(", ") }}

          </td>
          <td>
            <span v-for="reference in version.references">

              <a v-if="reference.includes('issues/')" :href="reference">Issue</a>
              <a v-else-if="reference.includes('hackerone')" :href="reference">HackerOne</a>
              <a v-else-if="reference.includes('gitlab-org/cves')" :href="reference">CVE data</a>
              <a v-else :href="reference">link</a>
              <br />
            </span>
          </td>
        </template>
      </paginated-table>
    </template>
  </div>
</template>
<script>
import Multiselect from "vue-multiselect";
import PaginatedTable from "./components/paginated-table.vue";

const uniqAndSort = (array) => {
  return Array.from(new Set(array)).filter(Boolean).sort();
};

let searchDefaults = {
  order: -1,
  orderKey: "severity",
  selectedSeverities: [],
  textSearch: "",
  version: null,
};

function eqSet(as, bs) {
  if (as.length !== bs.length) return false;
  for (let a of as) if (!bs.includes(a)) return false;
  return true;
}

export default {
  components: {
    PaginatedTable,
    Multiselect,
  },
  data() {
    return {
      data: [],
      loading: true,
      ...searchDefaults,
    };
  },
  async mounted() {
    this.data = (
      await Promise.all([
        fetch("./version_cve_map.json").then((response) => response.json()),
        fetch("./cves.json").then((response) => response.json()),
      ])
    ).flat();

    const params = new URLSearchParams(window.location.search);

    searchDefaults.version = this.allVersions[0];

    this.version = searchDefaults.version;

    Object.entries(searchDefaults).forEach(([key, value]) => {
      if (Array.isArray(value)) {
        const newVal = params.getAll(key);
        if (!eqSet(newVal, value)) {
          this[key] = newVal;
        }
        return;
      }

      const newVal = params.get(key);

      if (newVal && newVal !== value) {
        this[key] = newVal;
      }
    });
    this.$parent.pageView({ page: "cves" });
    this.loading = false;
  },
  updated() {
    const params = new URLSearchParams();
    Object.entries(searchDefaults).forEach(([key, value]) => {
      let newVal = this[key];

      if (Array.isArray(value)) {
        if (!eqSet(newVal, value)) {
          newVal.forEach((x) => {
            params.append(key, x);
          });
        }
        return;
      }

      if (newVal && newVal !== value) {
        params.set(key, newVal);
      }
      params.set("tab", "cves");
    });
    window.history.replaceState(
      {},
      "",
      window.location.protocol +
        "//" +
        window.location.host +
        window.location.pathname +
        "?" +
        params.toString()
    );
  },
  methods: {
    renderVersion(version) {
      return version.replace(/^0/, "").replace(/_0?/, ".");
    },
    compareSeverity(sev1, sev2) {
      const severities = ['low','medium','high','critical']
      sev1 = sev1.toLowerCase()
      sev2 = sev2.toLowerCase()
      if(severities.includes(sev1) && severities.includes(sev2)) {
        if(severities.indexOf(sev1) > severities.indexOf(sev2)) {
          return 1
        } else if(severities.indexOf(sev1) == severities.indexOf(sev2)) {
          return 0
        } else {
          return -1
        }
      } else {
        console.log("Invalid severity " + sev1 + sev2)
        return 0
      }
    },
    compareVersions(version1, version2) {
      const versionA = version1.split(".")
      const majorA = parseInt(versionA[0])
      const minorA = parseInt(versionA[1])
      const patchA = parseInt(versionA[2])

      const versionB = version2.split(".")
      const majorB = parseInt(versionB[0])
      const minorB = parseInt(versionB[1])
      const patchB = parseInt(versionB[2])
      if(majorA > majorB){
        return 1
      } else if(majorA == majorB){
        if(minorA > minorB){
          return 1
        } else if(minorA == minorB){
          if(patchA > patchB){
            return 1
          } else if(patchA == patchB){
            return 0
          } else {
            return -1
          }
        } else {
          return -1
        }
      } else {
        return -1
      }
    }
  },
  computed: {
    allVersions() {
      return Object.keys(this.data[0])
    },
    allSeverities() {
      return uniqAndSort(
        this.versions.map((version) => version.severity).flat()
      );
    },
    searchLower() {
      return this.textSearch.toLocaleLowerCase();
    },
    versions() {
      var versions = []
      for (const [version, cve_array] of Object.entries(this.data[0])) {
        for (const cve of cve_array) {
          const cve_object = this.data[1][cve]
          const version_entry = {"version":version,...cve_object}
          versions.push(version_entry)
        }
      }
      return versions
    },
    filteredVersions() {
      return this.versions
        .filter((version) => {
          let visible = true;

          if (visible && this.version) {
            visible = visible && this.compareVersions(version.version, this.version) == 0;
          }

          if (visible && this.selectedSeverities.length) {
            visible =
              visible && this.selectedSeverities.includes(version.severity);
          }

          if (visible && this.textSearch) {
            visible =
              visible &&
              (version.description.toLocaleLowerCase().includes(this.searchLower) ||
                version.cve_id
                  .toLocaleLowerCase()
                  .includes(this.searchLower));
          }

          return visible;
        })
        .sort((a, b) => {
          if(this.orderKey === "version") {
            return this.compareVersions(a[this.orderKey], b[this.orderKey]) * this.order
          } else if(this.orderKey === "severity") {
            return this.compareSeverity(a[this.orderKey], b[this.orderKey]) * this.order
          }
        });
    },
  },
};
</script>
